'
'Sample 20X2 program for BFFCOMMS Case 1 & 2
'
'Ian Hopper (BFF Design Ltd), Ian@builtforfun.co.uk
'June 2101
'
'http://builtforfun.co.uk/
'
'Setup for 20X2 pins...
'
'Green LED on B.0
'Amber LED on B.1
'Red LED on B.2
'
'Serial data by hardware serial pins B.6 and C.0
'

#picaxe 20x2

	'let dirsB = %11110111	'configure pin B.3 as inputs (for 64SPU-1 card use)
	'let dirsC = %00111000	'configure required C pins as inputs (for 64SPU-1 card use)
	

	symbol	data1 = b4
	symbol	data2 = b5
	symbol	data3 = b6
	symbol	data4 = b7
	symbol	data5 = b8
	
	
'Set frequency
	
	setfreq m64
	

'Set up the hardware serial input	- hserin command receive at 115200 with "N" format on read and write
	
	hsersetup B115200_64, %110



'====================================================================

Start:	

'Light the amber LED

	switchon B.1
	

'Wait indefinately for character "A" on hserin then read a further 4 bytes to scratchpad address 0+

	hserin 0, 4, (65)
	
'Read the scratchpad data
	
	get 0, data2, data3, data4, data5
	
	
'Switch Amber off

	switchoff B.1
	
	
'Send some of the data back preceeded by the Aacii string "CD"
	
	hserout 0, ("CD", data3, data4, data5, data3, data4, data5)
	
	
'Switch Green on and off to indicate read write has taken place
	
	switchon B.0
	
	pause 8000
	
	switchoff B.0
	
	
'Back for another loop

	goto Start