'
'Sample 20X2 program for BFFCOMMS Case 3
'
'Flash green, amber or red LED in response to Serial command from PC
'
'Ian Hopper (BFF Design Ltd), Ian@builtforfun.co.uk
'June 2101
'
'http://builtforfun.co.uk/
'
'Setup for 20X2 pins...
'
'Green LED on B.0
'Amber LED on B.1
'Red LED on B.2
'
'Serial data by hardware serial pins B.6 and C.0
'

#picaxe 20x2

	'let dirsB = %11110111	'configure pin B.3 as inputs (for 64SPU-1 card use)
	'let dirsC = %00111000	'configure required C pins as inputs (for 64SPU-1 card use)

	symbol	data1 = b4
	symbol	data2 = b5
	symbol	data3 = b6
	symbol	data4 = b7
	symbol	data5 = b8
	
	
'Set frequency
	
	setfreq m64
	

'Set up the hardware serial input	- hserin command receive at 115200 with "N" format on read and write
	
	hsersetup B115200_64, %110



'====================================================================



'Flash the amber LED to indicate power up

	gosub Flash_Amber
	
	
Start:	
	

'Wait indefinately for character "X" (88) on hserin then read a further byte to scratchpad address 0

	hserin 0, 1, (88)
	
	
'Read the data byte
	
	get 0, data1
	
	
'Send receipt acknowledgement
	
	hserout 0, ("CD", data1)
	
	
'Quick blink on green to visually show data receipt

	switchon B.0
	pause 200
	switchoff B.0
	pause 4000
	
	
'Flash the correct LED if G (71) , A (65) or R (82) received

	if data1 = 71 then gosub Flash_Green
	
	if data1 = 65 then gosub Flash_Amber
	
	if data1 = 82 then gosub Flash_Red 
	
	
'Back for another loop

	goto Start
	


'Subroutines to flash LED's
	
	
Flash_Green:

	switchon B.0
	
	pause 8000
	
	switchoff B.0
	
return


Flash_Amber:

	switchon B.1
	
	pause 8000
	
	switchoff B.1
	
return


Flash_Red:

	switchon B.2
	
	pause 8000
	
	switchoff B.2
	
return