'
'Sample 20X2 program for BFFCOMMS Case 4
'
'Vary pulse length outputs in response to joystick positions from PC
'
'Ian Hopper (BFF Design Ltd), Ian@builtforfun.co.uk
'June 2101
'
'http://builtforfun.co.uk/
'
'Setup for 20X2 pins...
'
'Green LED on B.0
'Amber LED on B.1
'Red LED on B.2
'
'Serial data by hardware serial pins B.6 and C.0
'

#picaxe 20x2

	'let dirsB = %11110111	'configure pin B.3 as inputs (for 64SPU-1 card use)
	'let dirsC = %00111000	'configure required C pins as inputs (for 64SPU-1 card use)

	symbol	data1 = b4
	symbol	data2 = b5
	symbol	data3 = b6
	symbol	data4 = b7
	symbol	data5 = b8
	
	symbol	pulse1 = w18
	symbol	pulse2 = w19
	symbol	pulse3 = w20
	
	
'Set frequency
	
	setfreq m64
	

'Set up the hardware serial input	- hserin command receive at 115200 with "N" format on read and write
	
	hsersetup B115200_64, %110



'====================================================================



'Flash the amber LED to indicate power up

	gosub Flash_Amber
	
	
Start:	
	

'Wait indefinately for character "X" (88) on hserin then read a further 4 bytes to scratchpad address 0

	hserin 0, 4, (88)
	
	
'Read the data bytes
	
	get 0, data1, data2, data3, data4
	
	
'Check that 2nd byte is also "X" if not look again

	if data1 != 88 then goto Start
	
	
'Send receipt acknowledgement
	
	hserout 0, ("CD", data1)
	
	
'Set pulse lengths based on received stick positions, gives lengths that will show variation of brightness in the LED's

	pulse1 = data2 * 62 / 10
	pulse2 = data3 * 62 / 10
	pulse3 = data4 * 62 / 10
	
	
'And send out the pulses on pins B.0 to B.2

	pulsout B.0, pulse1
	pulsout B.1, pulse2
	pulsout B.2, pulse3
	
	
'Back for another loop

	goto Start
	


'Subroutines to flash LED's
	
	
Flash_Green:

	switchon B.0
	
	pause 8000
	
	switchoff B.0
	
return


Flash_Amber:

	switchon B.1
	
	pause 8000
	
	switchoff B.1
	
return


Flash_Red:

	switchon B.2
	
	pause 8000
	
	switchoff B.2
	
return